use std::env::args;
use std::fs::File;
use std::io::BufRead;
use std::io::BufReader;

fn foo<F: FnOnce(usize, usize) -> bool + Copy>(numbers: &Vec<i32>, k: usize, f: F) -> i32 {
    let mut result = 0;
    let mut i = k;

    while i > 0 {
        i -= 1;
        let ones = numbers.iter().filter(|x| (*x >> i) & 1 == 1).count();
        let pick = if f(ones, numbers.len()) {1} else {0};
        result |= pick << i;
    }

    return result;
}

fn main() {
    let path = args().nth(1).unwrap();
    let file = File::open(path).unwrap();

    let mut numbers = Vec::new();
    let mut k = 0;
    for line in BufReader::new(file).lines() {
        let l = line.unwrap();
        let i = i32::from_str_radix(&l, 2).unwrap();
        numbers.push(i);
        k = l.len();
    }

    let a = foo(&numbers, k, |ones, n| ones * 2 >= n);
    let b = foo(&numbers, k, |ones, n| ones * 2 < n);

    print!("{}\n", a * b);
}
